#include "behaviour.h"

void parse_key_stack(GameControl** gamec) {

	guint command[3] = {0};
	gint command_length = 0;
	gboolean command_complete = FALSE;

	if(g_list_length((*gamec)->key_stack) > 0) {
	
		command[0] = (guint)g_list_first((*gamec)->key_stack)->data;
		(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);	

		switch(command[0]) {
			
			case GDK_m:
			case GDK_d:
			case GDK_U:
			case GDK_G:
				command_length = 3;
				break; 
			case GDK_u:
			case GDK_l:
			case GDK_t:
			case GDK_f:
			case GDK_g:
				command_length = 2;
				break;
			default:
				command_length = 1;
				break;
	
		}
	
		switch(command_length) {
	
			case 3:
				if(g_list_length((*gamec)->key_stack) == 2) {
		
					command[1] = (guint)g_list_first((*gamec)->key_stack)->data;
					(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);
					command[2] = (guint)g_list_first((*gamec)->key_stack)->data;
					(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);
					command_complete = TRUE;
	
				}
				if(g_list_length((*gamec)->key_stack) == 1) {
		
					command[1] = (guint)g_list_first((*gamec)->key_stack)->data;
					(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);
	
				}
				break;
			case 2:
				if(g_list_length((*gamec)->key_stack) == 1) {
	
					command[1] = (guint)g_list_first((*gamec)->key_stack)->data;
					(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);
					command_complete = TRUE;		
	
				}
				break;
			case 1:	
				command_complete = TRUE;
				break;
			default:
				break;

		}
	
		if(command_complete) {

			if((*gamec)->turn->cost_cnt == 0) {		
	
				do_command(gamec,command_length,command[0],command[1],command[2]);

			} else {

				command_complete = FALSE;

			}

		} 

		if(!command_complete){

			(*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(command[0]));
		
			if(command_length == 3) {
	
				if(command[1] != 0) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(command[1]));
				if(command[2] != 0) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(command[2]));
	
			}
	
			if(command_length == 2) {
	
				if(command[1] != 0) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(command[1]));
	
			}
	
		}
	
	}

}

void key_interface(GtkWidget* widget,GdkEventKey* event,GameControl** gamec) {

	gint n;

	if(event->type == GDK_KEY_PRESS) {

		n = g_list_length((*gamec)->key_stack);

		switch(event->keyval) {

			case GDK_m:
			case GDK_d:
			case GDK_U:
			case GDK_G:
				if(n == 0) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
				break;
			case GDK_u:
			case GDK_f:
			case GDK_l:
			case GDK_g:
			case GDK_t:
				if(n == 0) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
				break;
			case GDK_KP_Up:
			case GDK_KP_Page_Up:
			case GDK_KP_Right:
			case GDK_KP_Page_Down:
			case GDK_KP_Down:
			case GDK_KP_End:
			case GDK_KP_Left:
			case GDK_KP_Home:
				if(n < 3) {
					if(n > 0) {
						if(((guint)g_list_first((*gamec)->key_stack)->data < GDK_KP_Home) ||
				                   ((guint)g_list_first((*gamec)->key_stack)->data > GDK_KP_End)) {
							(*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
						}
					} else {
						(*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
					}
				} break;
			case GDK_bracketleft:
			case GDK_bracketright:
				if(n < 3) {
					if(n > 0) {
						if(((guint)g_list_first((*gamec)->key_stack)->data != GDK_bracketleft) &&
				                   ((guint)g_list_first((*gamec)->key_stack)->data != GDK_bracketright)) {
							(*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
						}
					} else {
						(*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
					}
				} break;
			case GDK_grave:
			case GDK_1:
			case GDK_2:
			case GDK_3:
			case GDK_4:
			case GDK_5:
			case GDK_6:
			case GDK_7:
			case GDK_8:
			case GDK_9:
			case GDK_0:
				if(n < 3) (*gamec)->key_stack = g_list_append((*gamec)->key_stack,GINT_TO_POINTER(event->keyval));
				break;
			default:
				break;

		}

	}

}

void do_command(GameControl** gamec,gint command_length,guint command,guint a,guint b) {

	Monster *what = NULL,*on = NULL,*bump = NULL;
	Item* weapon = NULL;
	gint param1,param2;

	if(command_length == 3) {

		switch(b) {
		
			case GDK_1:
				param2 = 11;
				break;
			case GDK_2:
				param2 = 12;
				break;
			case GDK_3:
				param2 = 13;
				break;
			case GDK_4:
				param2 = 14;
				break;
			case GDK_5:
				param2 = 15;
				break;
			case GDK_6:
				param2 = 16;
				break;
			case GDK_7:
				param2 = 17;
				break;
			case GDK_8:
				param2 = 18;
				break;
			case GDK_9:
				param2 = 19;
				break;
			case GDK_0:
				param2 = 20;
				break;
			case GDK_KP_Up:
				param2 = UP;
				break;
			case GDK_KP_Page_Up:
				param2 = UP_RIGHT;
				break;
			case GDK_KP_Right:
				param2 = RIGHT;
				break;
			case GDK_KP_Page_Down:
				param2 = DOWN_RIGHT;
				break;
			case GDK_KP_Down:
				param2 = DOWN;
				break;
			case GDK_KP_End:
				param2 = DOWN_LEFT;
				break;
			case GDK_KP_Left:
				param2 = LEFT;
				break;
			case GDK_KP_Home:
				param2 = UP_LEFT;
				break;
			default:
				param2 = 0;
				break;

		}

	} 
	if(command_length >= 2) {

		
		switch(a) {
		
			case GDK_1:
				param1 = 11;
				break;
			case GDK_2:
				param1 = 12;
				break;
			case GDK_3:
				param1 = 13;
				break;
			case GDK_4:
				param1 = 14;
				break;
			case GDK_5:
				param1 = 15;
				break;
			case GDK_6:
				param1 = 16;
				break;
			case GDK_7:
				param1 = 17;
				break;
			case GDK_8:
				param1 = 18;
				break;
			case GDK_9:
				param1 = 19;
				break;
			case GDK_0:
				param1 = 20;
				break;
			case GDK_KP_Up:
				param1 = UP;
				break;
			case GDK_KP_Page_Up:
				param1 = UP_RIGHT;
				break;
			case GDK_KP_Right:
				param1 = RIGHT;
				break;
			case GDK_KP_Page_Down:
				param1 = DOWN_RIGHT;
				break;
			case GDK_KP_Down:
				param1 = DOWN;
				break;
			case GDK_KP_End:
				param1 = DOWN_LEFT;
				break;
			case GDK_KP_Left:
				param1 = LEFT;
				break;
			case GDK_KP_Home:
				param1 = UP_LEFT;
				break;
			default:
				param1 = 0;
				break;

		}

	}

	switch(command) {

		case GDK_m:
			if((command_length == 3) && (param1 < 10) && (param2 < 10)) {

				what = (Monster*) MAP(direction_x((Coords*)(*gamec)->turn,param1),
				                      direction_y((Coords*)(*gamec)->turn,param1))->ios;

				if(what != NULL) {

					if(can_move_thing(gamec,what,param2,&bump) == YES_CLEAR) {
							
						move_thing(gamec,what,param2);

					}

				}
			} break;
		case GDK_U:
			if(command_length == 3) {

				if(param1 < 10) {

					what = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param1),
					                      direction_y((Coords*)((*gamec)->turn),param1))->ios;

				} else {

					what = (Monster*) lookup_contains((*gamec)->turn->contains,param1-10);

				}
				
				if(param2 < 10) {

					on = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param2),
					                    direction_y((Coords*)((*gamec)->turn),param2))->ios;

				} else {

					on = (Monster*) lookup_contains((*gamec)->turn->contains,param2-10);

				}

				if((what != NULL) && (on != NULL)) {

					if(what->use_on != NULL) {

						what->use_on(gamec,what,on);
						((*gamec)->turn->cost_cnt) += (what->use_cost);
							
					}

				}

			} break;
		case GDK_u:
			if(command_length == 2) {

				if(param1 < 10) {

					what = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param1),
					                      direction_y((Coords*)((*gamec)->turn),param1))->ios;

					if(what != NULL) {
		
						if(what->use != NULL) {
							
							what->use(gamec,what);
							((*gamec)->turn->cost_cnt) += (what->use_cost);
		
						}

					}

				} else {

					what = (Monster*) lookup_contains((*gamec)->turn->contains,param1-10);

					if(what != NULL) {
		
						if(what->use != NULL) {

							what->use(gamec,what);
							((*gamec)->turn->cost_cnt) += (what->use_cost);
				
						}

					}

				}


			} break;
		case GDK_f:
		case GDK_l:
			if(command_length == 2) {

				if(param1 < 10) {

					what = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param1),
					                      direction_y((Coords*)((*gamec)->turn),param1))->ios;

					if(what != NULL) {
		
						g_print("%s\n",what->name->str);

					}

				} else {

					what = (Monster*) lookup_contains((*gamec)->turn->contains,param1-10);

					if(what != NULL) {
		
						g_print("%s\n",what->name->str);

					}

				}

			} break;
		case GDK_G:
			if((command_length == 3) && (param1 < 10) && (param2 > 10)) {

				what = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param1),
				                      direction_y((Coords*)((*gamec)->turn),param1))->ios;

				if(what != NULL) {
		
					item_map_to_contains(gamec,(Item*)(*gamec)->turn,param2-10,(Item*)what);
					(*gamec)->turn->cost_cnt = 1;
					(*gamec)->inv = NULL;
				
				}

			} break;
		case GDK_g:
			if((command_length == 2) && (param1 < 10)) {

				what = (Monster*) MAP(direction_x((Coords*)((*gamec)->turn),param1),
				                      direction_y((Coords*)((*gamec)->turn),param1))->ios;

				if(what != NULL) {
		
					item_map_to_contains(gamec,(Item*)(*gamec)->turn,
					                     find_lowest_free_key(((Item*)((*gamec)->turn))->contains),(Item*)what);
					(*gamec)->turn->cost_cnt = 1;
					(*gamec)->inv = NULL;
					
				}
	
			} break;
		case GDK_d:
			if((command_length == 3) && (param1 > 10) && (param2 < 10)) {

				what = (Monster*) lookup_contains((*gamec)->turn->contains,param1-10);

				if(what != NULL) {
		
					item_contains_to_map(gamec,(Item*)(*gamec)->turn,
					                     param1-10,direction_x((Coords*)(*gamec)->turn,param2),
					                               direction_y((Coords*)(*gamec)->turn,param2));
					(*gamec)->turn->cost_cnt = 1;
					(*gamec)->inv = NULL;
					
				}
	
			} break;
		case GDK_t:
			/* FIXME: make the monsters talkative... */

		case GDK_KP_Up:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,UP);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,UP,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,UP);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Page_Up:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,UP_RIGHT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,UP_RIGHT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,UP_RIGHT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Right:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,RIGHT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,RIGHT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,RIGHT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Page_Down:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,DOWN_RIGHT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,DOWN_RIGHT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,DOWN_RIGHT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Down:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,DOWN);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,DOWN,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,DOWN);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_End:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,DOWN_LEFT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,DOWN_LEFT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,DOWN_LEFT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Left:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,LEFT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,LEFT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,LEFT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_KP_Home:
			if(command_length == 1) {

				change_monster_state_facing((*gamec)->turn,(*gamec)->turn->state_flags & 7,UP_LEFT);
				add_update(gamec,(*gamec)->turn->x,(*gamec)->turn->y);
				if(can_move_thing(gamec,(*gamec)->turn,UP_LEFT,&bump) == YES_CLEAR) {
							
					move_thing(gamec,(*gamec)->turn,UP_LEFT);
					change_monster_state_step((*gamec)->turn);
					(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;

				}

			} 
			break;
		case GDK_bracketleft:
			if(command_length == 1) {

				weapon = attack(gamec,(*gamec)->turn,((*gamec)->turn->state_flags & 7),LEFT_HAND);
				(*gamec)->turn->cost_cnt = weapon->use_cost;

			} break;
		case GDK_bracketright:
			if(command_length == 1) {

				weapon = attack(gamec,(*gamec)->turn,((*gamec)->turn->state_flags & 7),RIGHT_HAND);
				(*gamec)->turn->cost_cnt = weapon->use_cost;

			} break;

		case GDK_grave:
		case GDK_1:
		case GDK_2:
		case GDK_3:
		case GDK_4:
		case GDK_5:
		case GDK_6:
		case GDK_7:
		case GDK_8:
		case GDK_9:
		case GDK_0:

	}

}

void mouse_interface(GtkWidget* widget,GdkEventButton* event,GameControl** gamec) {

	if(event->type == GDK_BUTTON_PRESS) {

		if(event->button == 1) {
			g_print("%s\n",(MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,
			               ((gint)(event->y)/TILE_SIZE)+AREA_OY)->ios == NULL) ? 
			               ("no item there..."):
			               (MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,((gint)(event->y)/TILE_SIZE)+AREA_OY)->ios->name->str));

		} else if(event->button == 3) {

			if(MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,((gint)(event->y)/TILE_SIZE)+AREA_OY)->mos != NULL) {
	
				if(INV_WINDOW == NULL)
					open_inv_window(gamec);
					(*gamec)->inv = MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,
  					                    ((gint)(event->y)/TILE_SIZE)+AREA_OY)->mos;
					display_contains(gamec,(*gamec)->inv);

			} else if(MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,((gint)(event->y)/TILE_SIZE)+AREA_OY)->ios != NULL) {

				if(INV_WINDOW == NULL)
					open_inv_window(gamec);
					(*gamec)->inv = (Monster*)MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,
  						                      ((gint)(event->y)/TILE_SIZE)+AREA_OY)->ios;
					if(MAP(((gint)(event->x)/TILE_SIZE)+AREA_OX,
					       ((gint)(event->y)/TILE_SIZE)+AREA_OY)->ios->properties & IS_CONTAINER)
						display_contains(gamec,(*gamec)->inv);

			}
	
			
		}

	}

}
void behave_do_nothing(GameControl** gamec,Monster* monster) {

}

void behave_guard_up_down(GameControl** gamec,Monster* monster) {

	Monster* bump = NULL;
	gint can,n;

	if(!(((gint)lookup_memory(monster->memory,0) == UP) || 
	     ((gint)lookup_memory(monster->memory,0) == DOWN) )) {

		monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);

	}

	if(monster->cost_cnt == 0) {

		if((gint)lookup_memory(monster->memory,1) == 10) {

			monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);

			if((gint)lookup_memory(monster->memory,0) == DOWN) {
				
				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),UP);

			} else {
		
				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),DOWN);

			}

		}

		if((gint)lookup_memory(monster->memory,0) == UP) {

			if((can = can_move_thing((gamec),monster,UP,&bump)) == YES_CLEAR) {

				move_thing((gamec),monster,UP);
				monster->cost_cnt = monster->move_cost;
			} else {


				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),DOWN);

			}

		} else {

			if((can = can_move_thing((gamec),monster,DOWN,&bump)) == YES_CLEAR) {

				move_thing((gamec),monster,DOWN);
				monster->cost_cnt = monster->move_cost;

			} else {

				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),UP);
	
			}

		}

		change_monster_state_step(monster);
		n = (gint)lookup_memory(monster->memory,1) + 1;
		monster->memory = set_memory(monster->memory,1,INT_MEM,n,NULL);

	} else {
	
		(monster->cost_cnt)--;

	}

}

gboolean try_to_hit(GameControl** gamec,Monster* tori,Monster* uke,gint weapon_sort) {

	gint rn = rand(),skill,a,b;
	gboolean res;
 	
	skill = ((a = lookup_skill(tori->weapon_skills,weapon_sort)) > (b = lookup_skill(tori->weapon_skills,BASE_WEAPON_SKILL))) ?
	        a : b;
	res = ((((100 - uke->armor) * skill) / 100) >= ((rn%100)+1));

	return res;

}

void cause_damage(GameControl** gamec,Monster* uke,gint dmg) {

	uke->cur_hp -= dmg;

	if(uke->cur_hp <= 0) {

		kill_monster(gamec,uke);

	}

}

void kill_monster(GameControl** gamec,Monster* uke) {

	Item* grave;
	gint i,j;

	g_print("%s has died\n",uke->name->str);

	if(uke->type == MONSTER) {

		/* later turn into corpse item, now I just take it off the map. */
		for(j=0;j<uke->height;j++)
		for(i=0;i<uke->width;i++)
			add_update(gamec,uke->x+i,uke->y+j);

		grave = new_item();
		set_item(gamec,grave,CROSS_GRAVE,"a shallow grave");
		add_to_map(gamec,(Monster*)grave,uke->x,uke->y);		
		(*gamec)->items = g_list_append((*gamec)->items,uke);

		uke->m_properties = SET(uke->m_properties,IS_DEAD);
		(*gamec)->monsters = g_list_remove((*gamec)->monsters,uke);
		remove_from_map(gamec,uke);
		uke->key = find_lowest_free_key(grave->contains);
		grave->contains = g_list_append(grave->contains,uke);

	} else if(uke->type == ITEM) {

		/* later turn into broken item, now I just take it off the map. */
		for(j=0;j<uke->height;j++)
		for(i=0;i<uke->width;i++)
			add_update(gamec,uke->x+i,uke->y+j);

		/* FIXME: make this pretty, with a broken item and stuff,
		   instead of just removing the item. */

		(*gamec)->items = g_list_remove((*gamec)->items,uke);
		remove_from_map(gamec,uke);

	}

}

Item* attack(GameControl** gamec,Monster* tori,gint direction,gint32 hand) {

	gint dmg,can,rn = rand();
	Monster* uke = NULL;
	Item* weapon;

	weapon = lookup_contains(tori->contains,hand);
	if(weapon != NULL && weapon->dmg_sort == WIELD) {

		can = can_move_thing(gamec,tori,direction,&uke);

		if(can == NO_ITEM || can == NO_MONSTER) {

			if(try_to_hit(gamec,tori,uke,weapon->sort) == TRUE) {

				dmg = (rn%((weapon->max_dmg)-(weapon->min_dmg)))+weapon->min_dmg;
				g_print("you hit with %s and cause %d damage\n",weapon->name->str,dmg);
				cause_damage(gamec,uke,dmg);

			} else {

				g_print("you miss\n");

			}

		}

		return weapon;

	} else {

		can = can_move_thing(gamec,tori,direction,&uke);
		if(can == NO_ITEM || can == NO_MONSTER) {

			if(try_to_hit(gamec,tori,uke,UNARMED) == TRUE) {

				dmg = (rn%((tori->max_dmg)-(tori->min_dmg)))+tori->min_dmg;
				g_print("you hit with %s and cause %d damage\n","your fist",dmg);
				cause_damage(gamec,uke,dmg);

			} else {

				g_print("you miss\n");

			}

		}

		return (Item*)tori;

	}

}

gint can_move_x_y(GameControl** gamec,gint x,gint y,gint access,Monster** bump_res) {

	/* map restrictions */
	
	if(x>=(MAX_MAP_X-1) || y>=(MAX_MAP_Y-1))
		return NO_ACCESS;

	if(x<0 || y<0)
		return NO_ACCESS;

	/* things in the way */

	if(MAP(x,y)->ios != NULL)
		(*bump_res) = (Monster*)(MAP(x,y)->ios);

	if(MAP(x,y)->mos != NULL)
		(*bump_res) = MAP(x,y)->mos;

	if((access & MAP(x,y)->kind) == 0)
		 return NO_ACCESS;

	if((MAP(x,y)->mos) != NULL)
		return NO_MONSTER;

	/* all clear */

	if((MAP(x,y)->ios) != NULL)
		if((MAP(x,y)->ios->properties & IS_TREADABLE) == 0)
			return NO_ITEM;

	return YES_CLEAR;

}

gint can_move_thing(GameControl** gamec,Monster* monster,gint direction,Monster** bump_res) {

	gint i,res;

	if(monster != NULL)
		if(monster->type == ITEM && CHK(monster->properties,IS_MOVABLE) == 0)
			return NO_STATIC;

	switch(direction) {

		case UP: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case UP_RIGHT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i+1,(monster->y)-1,
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+i-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case RIGHT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+i,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case DOWN_RIGHT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i+1,(monster->y)+(monster->height),
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+(monster->height)-i,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case DOWN: 
			for(i=0;i<monster->width;i++) {
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)+(monster->height),
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			}
			break;
		case DOWN_LEFT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1+i,(monster->y)+(monster->height),
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i,
 	                                              monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case LEFT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i,
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case UP_LEFT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1+i,(monster->y)-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		default: 
			break;

	}

	return res;

}

void move_thing(GameControl** gamec,Monster* monster,gint direction) {

	gint oldx,oldy,x,y,i,j;

	oldx = monster->x;
	oldy = monster->y;
	
	remove_from_map((gamec),monster);

	switch(direction) {
	
		case UP: 
			x = monster->x;
			y = monster->y-1;
			break;
		case UP_RIGHT:
			x = monster->x+1;
			y = monster->y-1;
			break;
		case RIGHT:
			x = monster->x+1;
			y = monster->y;
			break;
		case DOWN_RIGHT:
			x = monster->x+1;
			y = monster->y+1;
			break;
		case DOWN:
			x = monster->x;
			y = monster->y+1;
			break;
		case DOWN_LEFT:
			x = monster->x-1;
			y = monster->y+1;
			break;
		case LEFT:
			x = monster->x-1;
			y = monster->y;
			break;
		case UP_LEFT:
			x = monster->x-1;
			y = monster->y-1;
			break;
		default:
			x = monster->x;
			y = monster->y;
			break;
	}

	add_to_map((gamec),monster,x,y);

	add_update((gamec),(monster->x),(monster->y));

	for(j=0;j<monster->height;j++)
	for(i=0;i<monster->width;i++) {

		add_update((gamec),(oldx)+i,(oldy)+j);

	}

}

gint32 find_lowest_free_key(GList* contains) {

	GList* walker = contains;
	gint32 i = 1;

	while(walker != NULL) {

		if(walker->data != NULL) {

			if(((Item*)walker->data)->key == i) {

				i++;
				walker = contains;

			} else {

				walker = walker->next;

			}

		}

	}

	return i;

}

void item_map_to_contains(GameControl** gamec,Item* who,gint32 key,Item* item) {

	GList* walker = who->contains;

	if(item != NULL)
	if(CHK(item->properties,IS_PORTABLE) &&
	   ((who->type == MONSTER) || ((who->properties & IS_CONTAINER) && CHK(who->properties,IS_OPEN)))) {

		while(walker != NULL) {

			if(walker->data != NULL) {

				if(((Item*)walker->data)->key == key) {

					/* there's already something on that contains spot */

					if(((((Item*)walker->data)->cur_load + item->weight) <= ((Item*)walker->data)->max_load) && 
					   ((who->cur_load + item->weight) <= who->max_load)) {

						item->key = find_lowest_free_key(((Item*)walker->data)->contains);
						((Item*)walker->data)->contains = g_list_append(((Item*)walker->data)->contains,item);
						who->cur_load += item->weight;
						((Item*)walker->data)->cur_load += item->weight;
						remove_from_map(gamec,(Monster*)item);
						add_update(gamec,item->x,item->y);

					}

					return;

				} else {

					walker = walker->next;

				}

			}

		}

		if((who->cur_load + item->weight) <= who->max_load) {

			item->key = key;
			who->contains = g_list_append(who->contains,item);
			who->cur_load += item->weight;
			remove_from_map(gamec,(Monster*)item);
			add_update(gamec,item->x,item->y);

		}

	}

}

void item_contains_to_map(GameControl** gamec,Item* who,gint32 key,gint32 x,gint32 y) {

	GList* walker = who->contains;
	gint can;
	Monster* bump;

	if(who != NULL)
	while(walker != NULL) {

		if(walker->data != NULL) {

			if(((Item*)walker->data)->key == key) {

				if(((can = can_move_x_y(gamec,x,y,((Item*)walker->data)->access,&bump)) == YES_CLEAR) ||
				   ((can == NO_ITEM) && CHK(bump->properties,IS_STACKABLE))) {

					add_to_map(gamec,(Monster*)walker->data,x,y);
					who->contains = g_list_remove(who->contains,(Item*)walker->data);
					add_update(gamec,x,y);

				} 

				return;

			} else {

				walker = walker->next;

			}

		}

	}

}

void item_contains_to_contains(GameControl** gamec,Item* from,gint32 from_key,Item* to,gint32 to_key) {

	Item* item = NULL;
	GList* walker = from->contains;
	gboolean found = FALSE;

	if(CHK(from->properties,IS_CONTAINER)) {
	
		while((walker != NULL) && (found == FALSE)) {

			if(walker->data != NULL) {

				if(((Item*)walker->data)->key == from_key) {

					item = (Item*)walker->data;
					found = TRUE;

				}

			}

		}
	
	}

	walker = to->contains;

	if(CHK(to->properties,IS_CONTAINER) && CHK(to->properties,IS_OPEN) && (found == TRUE)) {

		while(walker != NULL) {

			if(walker->data != NULL) {

				if(((Item*)walker->data)->key == to_key) {

					/* there's already something on that contains spot */

					if(((((Item*)walker->data)->cur_load + item->weight) <= ((Item*)walker->data)->max_load) && 
					   ((to->cur_load + item->weight) <= to->max_load)) {

						item->key = find_lowest_free_key(((Item*)walker->data)->contains);
						((Item*)walker->data)->contains = g_list_append(((Item*)walker->data)->contains,item);
						to->cur_load += item->weight;
						((Item*)walker->data)->cur_load += item->weight;
						from->contains = g_list_remove(from->contains,item);
						from->cur_load -= item->weight;

					}

					return;

				} else {

					walker = walker->next;

				}

			}

		}

		if((to->cur_load + item->weight) <= to->max_load) {

			item->key = to_key;
			to->contains = g_list_append(to->contains,item);
			to->cur_load += item->weight;
			from->contains = g_list_remove(from->contains,item);			
			from->cur_load -= item->weight;

		}		

	}

}

gint direction_x(Coords* from_where,gint direction) {

	gint x;

	switch(direction) {

		case UP:
			x = UP_X;
			break;
		case UP_RIGHT:
			x = UP_RIGHT_X;
			break;
		case RIGHT:
			x = RIGHT_X;
			break;
		case DOWN_RIGHT:
			x = DOWN_RIGHT_X;
			break;
		case DOWN:
			x = DOWN_X;
			break;
		case DOWN_LEFT:
			x = DOWN_LEFT_X;
			break;
		case LEFT:
			x = LEFT_X;
			break;
		case UP_LEFT:
			x = UP_LEFT_X;
			break;

	}

	return ((from_where->x)+x);

}

gint direction_y(Coords* from_where,gint direction) {

	gint y;

	switch(direction) {

		case UP:
			y = UP_Y;
			break;
		case UP_RIGHT:
			y = UP_RIGHT_Y;
			break;
		case RIGHT:
			y = RIGHT_Y;
			break;
		case DOWN_RIGHT:
			y = DOWN_RIGHT_Y;
			break;
		case DOWN:
			y = DOWN_Y;
			break;
		case DOWN_LEFT:
			y = DOWN_LEFT_Y;
			break;
		case LEFT:
			y = LEFT_Y;
			break;
		case UP_LEFT:
			y = UP_LEFT_Y;
			break;

	}

	return ((from_where->y)+y);

}

