#ifndef QUEST_BEHAVIOUR
#define QUEST_BEHAVIOUR

#include <gdk/gdkkeysyms.h>
#include "monster.h"
#include "map.h"
#include "xfuncs.h"
#include "types.h"
#include "global.h"

void parse_key_stack(GameControl** gamec);
void key_interface(GtkWidget* widget,GdkEventKey* event,GameControl** gamec);
void mouse_interface(GtkWidget* widget,GdkEventButton* event,GameControl** gamec);
void do_command(GameControl** gamec,gint command_length,guint command,guint a,guint b);

void behave_do_nothing(GameControl** gamec,Monster* monster);
void behave_guard_up_down(GameControl** gamec,Monster* monster);

gboolean try_to_hit(GameControl** gamec,Monster* tori,Monster* uke,gint weapon_sort);
void cause_damage(GameControl** gamec,Monster* uke,gint dmg);
void kill_monster(GameControl** gamec,Monster* uke);
Item* attack(GameControl** gamec,Monster* tori,gint direction,gint32 hand); 
	/* returns the weapon used (or monster itsself if unarmed) */

gint can_move_x_y(GameControl** gamec,gint x,gint y,gint access,Monster** bump);
gint can_move_thing(GameControl** gamec,Monster* monster,gint direction,Monster** bump);
void move_thing(GameControl** gamec,Monster* monster,gint direction);

gint32 find_lowest_free_key(GList* contains);
void item_map_to_contains(GameControl** gamec,Item* who,gint32 key,Item* item);
void item_contains_to_map(GameControl** gamec,Item* who,gint32 key,gint32 x,gint32 y);
void item_contains_to_contains(GameControl** gamec,Item* from,gint32 from_key,Item* to,gint32 to_key);

gint direction_x(Coords* from_where,gint direction);
gint direction_y(Coords* from_where,gint direction);

void use_thing(GameControl** gamec,Item* what);

#endif /* QUEST_BEHAVIOUR */
