#include "item.h"

Item* new_item() {

	Item* new = (Item*) g_malloc(sizeof(Item));

	new->key = -1;
	new->type = ITEM;
	new->x = 0;
	new->y = 0;

	new->name = g_string_new("new item");
	new->width = 1;
	new->height = 1;
	new->sprites = NULL;
	new->animates = FALSE;
	new->state = 0;
	new->access = 0;
	new->properties = 0;
	new->sort = UNKNOWN_SORT;
	new->sub_sort = UNKNOWN_SUB_SORT;
	new->weight = 0;
	new->value = 0;
	new->max_hp = 1;
	new->cur_hp = 1;
	new->dmg_sort = CONTACT;
	new->min_dmg = 0;
	new->max_dmg = 0;
	new->use_cost = 1;
	new->armor = 0;
	new->max_load = 0;
	new->cur_load = 0;
	new->contains = NULL;
	new->inside = NULL;
	new->stacked = NULL;
	new->behaviour = NULL;
	new->use = NULL;
	new->use_on = NULL;

	return new;

}

void zap_item(Item* item) {

	if(item != NULL) {

		if(item->name != NULL) {
			
			g_string_free(item->name,FALSE);
			item->name = NULL;
		
		}
		
		if(item->sprites != NULL) {

			g_list_foreach(item->sprites,(GFunc)g_free,NULL);
			item->sprites = NULL;

		}

		if(item->contains != NULL) {

			item->contains = NULL;

		}
		
		item->stacked = NULL;
		item->inside = NULL;

		g_free(item);
		item = NULL;

	}

}

void set_item(GameControl** gamec,Item* item,guint16 sub_sort,gchar* name) {

	gint rn = rand();
	item->sub_sort = sub_sort;
	item->name = g_string_assign(item->name,name);

	switch(item->sub_sort) {

		case SHORT_SWORD:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,SHORT_SWORD_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_STACKABLE | IS_TREADABLE);
			item->sort = SWORD;
			item->weight = 40+(rn%10);
			item->value = 1250+((rn%10)*10);
			item->max_hp = 20;
			item->cur_hp = 20;
			item->dmg_sort = WIELD;
			item->min_dmg = 1;
			item->max_dmg = 8;
			item->use_cost = 3;
			item->armor = 90;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case SPIKED_CLUB:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,SPIKED_CLUB_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | WATER | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->sort = CLUB;
			item->weight = 80+(rn%10);
			item->value = 8+(rn%10);
			item->max_hp = 10;
			item->cur_hp = 10;
			item->dmg_sort = WIELD;
			item->min_dmg = 2;
			item->max_dmg = 12;
			item->use_cost = 5;
			item->armor = 40;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case RED_RUG:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,RED_RUG_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->sort = RUG;
			item->weight = 45+(rn%10);
			item->value = 5000+((rn%10)*100);
			item->max_hp = 2;
			item->cur_hp = 2;
			item->dmg_sort = NEVER;
			item->min_dmg = 0;
			item->max_dmg = 0;
			item->use_cost = 1;
			item->armor = 10;
			item->max_load = 0;
			item->cur_load = 0;
			item->use_on = use_rug_on_fire;
			break;

		case PURPLE_RUG:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,PURPLE_RUG_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->sort = RUG;
			item->weight = 45+(rn%10);
			item->value = 7500+((rn%10)*10);
			item->max_hp = 2;
			item->cur_hp = 2;
			item->dmg_sort = NEVER;
			item->min_dmg = 0;
			item->max_dmg = 0;
			item->use_cost = 1;
			item->armor = 10;
			item->max_load = 0;
			item->cur_load = 0;
			item->use_on = use_rug_on_fire;
			break;
			
		case BIG_BOULDER:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,BIG_BOULDER_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE);
			item->sort = BOULDER;
			item->weight = 50000+(rn%1000);
			item->value = 0;
			item->max_hp = 250;
			item->cur_hp = 250;
			item->dmg_sort = MISSILE;
			item->min_dmg = 2;
			item->max_dmg = 20;
			item->use_cost = 10;
			item->armor = 90;
			item->max_load = 0;
			item->cur_load = 0;
			break;
			
		case MOSSY_BOULDER:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,THREE_BOULDERS_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE);
			item->sort = BOULDER;
			item->weight = 30000+(rn%1000);
			item->value = 0;
			item->max_hp = 150;
			item->cur_hp = 150;
			item->dmg_sort = MISSILE;
			item->min_dmg = 1;
			item->max_dmg = 15;
			item->use_cost = 8;
			item->armor = 90;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case DARK_BARREL:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,DARK_BARREL_1);
			item->sprites = add_sprite(item->sprites,OK_2,DARK_BARREL_OPEN_1);
			item->sprites = add_sprite(item->sprites,BROKEN,SMASHED_BARREL_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (WATER | GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_FLAMABLE | IS_CONTAINER);
			item->sort = BARREL;
			item->weight = 80+(rn%15);
			item->value = 800+(rn%100);
			item->max_hp = 10;
			item->cur_hp = 10;
			item->dmg_sort = MISSILE;
			item->min_dmg = 1;
			item->max_dmg = 6;
			item->use_cost = 8;
			item->armor = 60;
			item->max_load = 2000;
			item->cur_load = 0;
			item->use = open_close_thing;
			item->use_cost = 2;
			break;

		case LIGHT_BARREL:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,LIGHT_BARREL_1);
			item->sprites = add_sprite(item->sprites,OK_2,LIGHT_BARREL_OPEN_1);
			item->sprites = add_sprite(item->sprites,BROKEN,SMASHED_BARREL_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (WATER | GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_FLAMABLE | IS_CONTAINER);
			item->sort = BARREL;
			item->weight = 80+(rn%10);
			item->value = 800+(rn%100);
			item->max_hp = 10;
			item->cur_hp = 10;
			item->dmg_sort = MISSILE;
			item->min_dmg = 1;
			item->max_dmg = 6;
			item->use_cost = 8;
			item->armor = 60;
			item->max_load = 2000;
			item->cur_load = 0;
			item->use = open_close_thing;
			item->use_cost = 2;
			break;
			
		case BIG_TREE:
			item->width = 3;
			item->height = 3;
			item->sprites = add_sprite(item->sprites,OK_1,BIG_TREE_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (MOUNTAIN | WATER | GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_BASHABLE | IS_FLAMABLE);
			item->sort = TREE;
			item->weight = 100000+(rn%50000);
			item->value = 0;
			item->max_hp = 500;
			item->cur_hp = 500;
			item->dmg_sort = WIELD;
			item->min_dmg = 8;
			item->max_dmg = 80;
			item->use_cost = 12;
			item->armor = 70;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case SMALL_TREE:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,TWO_TREES_1);
			item->sprites = add_sprite(item->sprites,BROKEN,WOOD_SHREDS_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (MOUNTAIN | WATER | GRASS | DIRT | STREET | ICE | SAND);
			item->properties = (IS_BASHABLE | IS_FLAMABLE);
			item->sort = TREE;
			item->weight = 8000+(rn%1000);
			item->value = 0;
			item->max_hp = 90;
			item->cur_hp = 90;
			item->dmg_sort = WIELD;
			item->min_dmg = 2;
			item->max_dmg = 16;
			item->use_cost = 7;
			item->armor = 70;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case MUSHROOM_RING_FUNGUS:
			item->width = 2;
			item->height = 2;
			item->sprites = add_sprite(item->sprites,OK_1,MUSHROOM_RING_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT);
			item->properties = (IS_BASHABLE | IS_FLAMABLE | IS_TREADABLE);
			item->sort = FUNGUS;
			item->weight = 7+(rn%10);
			item->value = 0;
			item->max_hp = 10;
			item->cur_hp = 10;
			item->dmg_sort = NEVER;
			item->min_dmg = 0;
			item->max_dmg = 0;
			item->use_cost = 1;
			item->armor = 10;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		case CAMP_FIRE:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,CAMPFIRE_DOUSED);
			item->sprites = add_sprite(item->sprites,ON_FIRE_1,CAMPFIRE_BURNING_1);
			item->sprites = add_sprite(item->sprites,ON_FIRE_2,CAMPFIRE_BURNING_2);
			item->sprites = add_sprite(item->sprites,ON_FIRE_3,CAMPFIRE_BURNING_3);
			item->sprites = add_sprite(item->sprites,ON_FIRE_4,CAMPFIRE_BURNING_4);
			item->animates = TRUE;
			item->state = ((rn%4) + ON_FIRE_1);
			item->access = (MOUNTAIN | GRASS | DIRT | STREET | SAND);
			item->properties = (IS_BASHABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->sort = FIRE;
			item->weight = 50+(rn%10);
			item->value = 0;
			item->max_hp = 5;
			item->cur_hp = 5;
			item->dmg_sort = CONTACT;
			item->min_dmg = 2;
			item->max_dmg = 8;
			item->use_cost = 1;
			item->armor = 20;
			item->max_load = 0;
			item->cur_load = 0;
			item->use = use_fire;
			break;

		case CROSS_GRAVE:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,CROSS_1);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (GRASS | DIRT | SAND | STREET);
			item->properties = (IS_BASHABLE | IS_FLAMABLE | IS_CONTAINER);
			item->sort = GRAVE;
			item->weight = 20+(rn%10);
			item->value = 0;
			item->max_hp = 10;
			item->cur_hp = 10;
			item->dmg_sort = NEVER;
			item->min_dmg = 0;
			item->max_dmg = 0;
			item->use_cost = 1;
			item->armor = 30;
			item->max_load = 0;
			item->cur_load = 0;
			break;

		default:
			item->width = 1;
			item->height = 1;
			item->sprites = add_sprite(item->sprites,OK_1,UNKNOWN_ITEM_SPRITE);
			item->animates = FALSE;
			item->state = OK_1;
			item->access = (MOUNTAIN | WATER | GRASS | DIRT | STREET | LAVA | ICE | SAND);
			item->properties = 0;
			item->sort = UNKNOWN_SORT;
			item->weight = 0;
			item->value = 0;
			item->max_hp = 1;
			item->cur_hp = 1;
			item->dmg_sort = NEVER;
			item->min_dmg = 0;
			item->max_dmg = 0;
			item->use_cost = 1;
			item->armor = 0;
			item->max_load = 0;
			item->cur_load = 0;

	}

	if(g_list_find((*gamec)->items,item) == NULL) {

		(*gamec)->items = g_list_append((*gamec)->items,item);

	}

}

Item* lookup_contains(GList* contains,gint32 key) {

	GList* walker = contains;

	while(walker != NULL) {

		if(((Item*)walker->data) != NULL)
		if(((Item*)walker->data)->key == key) {
			
			return ((Item*)walker->data);

		} else {

			walker = walker->next;

		}

	}

	return NULL;

}

void open_close_thing(GameControl** gamec,Item* what) {

	if(what != NULL) {

		if(CHK(what->properties,IS_CONTAINER)) {

			if(CHK(what->properties,IS_OPEN)) {

				what->state = OK_1;
				what->properties = CLR(what->properties,IS_OPEN);

			} else {

				what->state = OK_2;
				what->properties = SET(what->properties,IS_OPEN);

			}

			add_update(gamec,what->x,what->y);

		}

		/*
		} else if(CHK(what->properties,IS_DOOR)) {

		}
		*/

	}

}

void use_rug_on_fire(GameControl** gamec,Item* what,Item* on) {

	if((what != NULL) && (on != NULL)) {

		if((what->sort == RUG) && (on->sort == FIRE)) {

			on->state = OK_1;
			on->animates = FALSE;
			add_update(gamec,on->x,on->y);

		}

	}

}

void use_fire(GameControl** gamec,Item* what) {

	gint rn = rand();

	if(what != NULL) {

		if(what->sort == FIRE) {

			if(what->state < ON_FIRE_1 || what->state > ON_FIRE_4) {

				what->state = ((rn%4) + ON_FIRE_1);
				what->animates = TRUE;
				add_update(gamec,what->x,what->y);

			}

		}

	}

}