#ifndef QUEST_XFUNCS
#define QUEST_XFUNCS

#include <gtk/gtk.h>
#include "gamec.h"	/* for do_cycle() */
#include "sprite.h"	/* for make_map_area() */
#include "types.h"
#include "global.h"

void init_widgets(GameControl** gamec);

MapWin* new_map_window();
void zap_map_window(MapWin* map_window);
InvWin* new_inv_window();
void zap_inv_window(InvWin* inv_window);

void open_map_window(GameControl** gamec);
void open_inv_window(GameControl** gamec);
void close_inv_window(GtkWidget *widget,GdkEvent* event,GameControl** gamec);

void print_image_list(GameControl** gamec);
void print_monster_list(GameControl** gamec);
void print_item_list(GameControl** gamec);
void print_cycle_cnt(GameControl** gamec);
void print_key_stack(GameControl** gamec);
void get_map_menu(GameControl** gamec);
void get_inv_menu(GameControl** gamec);

void about(GameControl** gamec);
void about_close(GtkWidget *widget,gpointer data);

gint delete_event(GtkWidget *widget,GdkEvent *event,gpointer data);
void destroy(GtkWidget *widget,gpointer data);
gint configure_event(GtkWidget *widget,GdkEventConfigure *event,GameControl** gamec);
gint expose_event(GtkWidget *widget,GdkEventExpose *event,GameControl** gamec);
        
void display_contains(GameControl** gamec,Monster* who);

#endif /* QUEST_XFUNCS */
